package RSSReader::Gtk2UI::DiscoverFeedSilent;
use strict;
use RSSReader::Gtk2UI::Dialog;
use RSSReader::Gtk2UI;
use RSSReader::Fetcher::FindFeed;
use RSSReader::Category;
use RSSReader::Feed;
use RSSReader::Gtk2UI::MainWindow;

sub run {
	my $c = shift;
	my %a = @_;

	my $category = $a{category} || RSSReader::Category->new(id=>1);

	return undef unless $a{url};
	my $id = RSSReader::Gtk2UI::MainWindow->new->status_bar_add("Finding feed in $a{url}");
	my $result = RSSReader::Fetcher::FindFeed->run(url=>$a{url});
	if (!$result) {
		RSSReader::Gtk2UI::Dialog->run("Could not find a feed in '$a{url}'");
		RSSReader::Gtk2UI::MainWindow->new->status_bar_remove($id);
		return undef;
	}
        my $f = RSSReader::Feed->create(        category       => $category,
                                                url            => $result->{url},
                                                label          => $result->{xml}->{channel}->{title},
                                                fetch_interval => 0
                                        );
	if (! $f ) {
                RSSReader::Gtk2UI::Dialog->run($@);
		RSSReader::Gtk2UI::MainWindow->new->status_bar_remove($id);
		return undef;
	}

	RSSReader::Gtk2UI->new()->get_feed($f);
	RSSReader::Gtk2UI::MainWindow->new->status_bar_remove($id);
	return undef;
}
1;
